/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* ArrowB.h,v 1.5 1995/10/19 12:44:09 pgw Exp */

#if !defined(_XARM_ARROWB_H_)
#define _XARM_ARROWB_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/Primitive.h>

class ArrowButtonClass : public PrimitiveClass {
 protected:
   ArrowButtonClass() {} /* only a derived class can make this */

   virtual WidgetClass classPointer() { return xmArrowButtonWidgetClass; }
   virtual _XtString className() { return (_XtString) "XmArrowButton"; }
 public:
   /* callbacks */
   void activateCallback(XtCallbackProc funcp, XtPointer data = NULL);
   void armCallback(XtCallbackProc funcp, XtPointer data = NULL);
   void disarmCallback(XtCallbackProc funcp, XtPointer data = NULL);

   /* resources */
   void arrowDirection(unsigned char);
   unsigned char arrowDirection();
   void multiClick(unsigned char);
   unsigned char multiClick();
};

class ArrowButton : public ArrowButtonClass {
 public:
   ArrowButton(Widget parent, 
               ArgList arglist = NULL, 
               Cardinal argcnt = 0, 
               _XtString name = NULL);
   ArrowButton(_XtString name, Widget parent);
};

#endif
