/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* CascadeB.h,v 1.5 1995/10/19 12:44:12 pgw Exp */

#if !defined(_XARM_CASCADEB_H_)
#define _XARM_CASCADEB_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/Label.h>

class CascadeButtonClass : public LabelClass {
 protected:
   CascadeButtonClass() {} /* only a derived class can make this */

   virtual WidgetClass classPointer() { return xmCascadeButtonWidgetClass; }
   virtual _XtString className() { return (_XtString) "XmCascadeButton"; }
 public:
   /* Callbacks */
   void activateCallback(XtCallbackProc funcp, XtPointer data = NULL);
   void cascadingCallback(XtCallbackProc funcp, XtPointer data = NULL);

   /* resources */
   void cascadePixmap(Pixmap);
   Pixmap cascadePixmap();
   void mappingDelay(int);
   int mappingDelay();
   void subMenuId(Widget sub); /* expects a PulldownMenu */
   Widget subMenuId();
};

class CascadeButton : public CascadeButtonClass {
 public:
   CascadeButton(Widget parent, char *str, _XtString name = NULL);
   CascadeButton(Widget parent, 
                 ArgList arglist = NULL, 
                 Cardinal cnt = 0, 
                 _XtString name = NULL);
   CascadeButton(_XtString name, Widget parent);
};

#endif
