/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* Core.h,v 1.5 1995/10/19 12:44:16 pgw Exp */

#if !defined(_XARM_CORE_H_)
#define _XARM_CORE_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/RectObj.h>

class CoreClass : public _RectObjClass {
 protected:
   CoreClass() {} /* only a derived class can make this */
   virtual WidgetClass classPointer() { return coreWidgetClass; }
   virtual _XtString className() { return (_XtString) "Core"; }
 public:
   /* resources */
   void accelerators(XtAccelerators);
   XtAccelerators accelerators();
   void background(Pixel);
   Pixel background();
   void backgroundPixmap(Pixmap);
   Pixmap backgroundPixmap();
   void borderColor(Pixel);
   Pixel borderColor();
   void borderPixmap(Pixmap);
   Pixmap borderPixmap();
   Colormap colormap();
   int depth();
   Boolean mappedWhenManaged();
   void mappedWhenManaged(Boolean);
   Screen *screen();
   XtTranslations translations();
   void translations(XtTranslations);

};

#endif
