/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* DrawingA.h,v 1.5 1995/10/19 12:44:19 pgw Exp */

#if !defined(_XARM_DRAWINGA_H_)
#define _XARM_DRAWINGA_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/Manager.h>

class DrawingAreaClass : public ManagerClass {
 protected:
   DrawingAreaClass() {}
   virtual WidgetClass classPointer() { return xmDrawingAreaWidgetClass; }
   virtual _XtString className() { return (_XtString) "XmDrawingArea"; }
 public:
   /* callbacks */
   void exposeCallback(XtCallbackProc funcp, XtPointer data = NULL);
   void inputCallback(XtCallbackProc funcp, XtPointer data = NULL); 
   void resizeCallback(XtCallbackProc funcp, XtPointer data = NULL); 
 
   /* resources */
   void marginHeight(Dimension); 
   Dimension marginHeight(); 
   void marginWidth(Dimension);
   Dimension marginWidth();
   void resizePolicy(unsigned char);
   unsigned char resizePolicy();
};   

class DrawingArea : public DrawingAreaClass {
 public:
   DrawingArea(Widget parent, 
               ArgList arglist = NULL, 
               Cardinal cnt = 0,
               _XtString name = NULL);
   DrawingArea(_XtString name, Widget parent);
};


#endif
