/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* DrawnB.h,v 1.5 1995/10/19 12:44:20 pgw Exp */

#if !defined(_XARM_DRAWNB_H_)
#define _XARM_DRAWNB_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/Label.h>

class DrawnButtonClass : public LabelClass {
 protected:
   DrawnButtonClass() {}
   virtual WidgetClass classPointer() { return xmDrawnButtonWidgetClass; }
   virtual _XtString className() { return (_XtString) "XmDrawnButton"; }
 public:
   /* callbacks */
   void activateCallback(XtCallbackProc funcp, XtPointer data = NULL); 
   void armCallback(XtCallbackProc funcp, XtPointer data = NULL); 
   void disarmCallback(XtCallbackProc funcp, XtPointer data = NULL); 
   void exposeCallback(XtCallbackProc funcp, XtPointer data = NULL); 
   void resizeCallback(XtCallbackProc funcp, XtPointer data = NULL); 

   /* resources */
   void multiClick(unsigned char c);
   unsigned char multiClick();
   void pushButtonEnabled(Boolean b);
   Boolean pushButtonEnabled();
   void shadowType(unsigned char c);
   unsigned char shadowType();
};
   
class DrawnButton : public DrawnButtonClass {
 public:
   DrawnButton(Widget parent,
               ArgList arglist = NULL,
               Cardinal cnt = 0,
               _XtString name = NULL);
   DrawnButton(_XtString name, Widget parent);
};

#endif
