/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* FileSB.h,v 1.5 1995/10/19 12:44:21 pgw Exp */

#if !defined(_XARM_FILESB_H_)
#define _XARM_FILESB_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/SelectioB.h>

class FileSelectionBoxClass : public SelectionBoxClass {
 protected:
   FileSelectionBoxClass() {}
   virtual WidgetClass classPointer() { return xmFileSelectionBoxWidgetClass; }
   virtual _XtString className() { return (_XtString) "XmFileSelectionBox"; }
 public:
   /* convenience routines */
   virtual Widget getChild(unsigned char);
   void doSearch(char *str); 

   /* resources */
   void directory(char *);
   char *directory();
   void directoryValid(Boolean);
   Boolean directoryValid();
   void dirListItems(XmStringTable);
   XmStringTable dirListItems();
   void dirListItemCount(int);
   int dirListItemCount();
   void dirListLabelString(char *);
   char *dirListLabelString();
   void dirMask(char *);
   char *dirMask();
   void dirSearchProc(XmSearchProc);
   XmSearchProc dirSearchProc();
   void dirSpec(char *);
   char *dirSpec();
   void fileListItems(XmStringTable);
   XmStringTable fileListItems();
   void fileListItemCount(int);
   int fileListItemCount();
   void fileListLabelString(char *);
   char *fileListLabelString();
   void fileSearchProc(XmSearchProc);
   XmSearchProc fileSearchProc();
   void fileTypeMask(unsigned char);
   unsigned char fileTypeMask();
   void filterLabelString(char *);
   char *filterLabelString();
   void listUpdated(Boolean);
   Boolean listUpdated();
   void noMatchString(char *);
   char *noMatchString();
   void pattern(char *);
   char * pattern();
   void qualifySearchDataProc(XmQualifyProc);
   XmQualifyProc qualifySearchDataProc();
   
 
};

class FileSelectionBox : public FileSelectionBoxClass {
 public:
   FileSelectionBox(Widget parent, 
                    ArgList arglist = NULL, 
                    Cardinal cnt = 0,
                    _XtString name = NULL);
   FileSelectionBox(_XtString name, Widget parent);
};

class FileSelectionDialog : public FileSelectionBoxClass {
 protected:
   virtual Widget createWidget(_XtString name, 
                               Widget parent, 
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   FileSelectionDialog(Widget parent, 
                       ArgList arglist = NULL, 
                       Cardinal cnt = 0,
                       _XtString name = NULL);
   FileSelectionDialog(_XtString name, Widget parent);
};

#endif
