/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* Form.h,v 1.5 1995/10/19 12:44:21 pgw Exp */

#if !defined(_XARM_FORM_H_)
#define _XARM_FORM_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/BulletinB.h>

class FormClass : public BulletinBoardClass {
 protected:
   FormClass() {} /* only a derived class can make this */
   virtual WidgetClass classPointer() { return xmFormWidgetClass; }
   virtual _XtString className() { return (_XtString) "XmForm"; } 
 public:
   /* resources */
   void fractionBase(int);
   int fractionBase();
   void horizontalSpacing(Dimension);
   Dimension horizontalSpacing();
   void rubberPositioning(Boolean);
   Boolean rubberPositioning();
   void verticalSpacing(Dimension);
   Dimension verticalSpacing();
};

class Form : public FormClass {
 public:
   Form(Widget parent,
        ArgList arglist = NULL,
        Cardinal cnt = 0,
        _XtString name = NULL);
   Form(_XtString name, Widget parent);
};

class FormDialog : public FormClass {
 protected:
   virtual Widget createWidget(_XtString name, 
                               Widget parent, 
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   FormDialog(Widget parent,
              ArgList arglist = NULL,
              Cardinal cnt = 0,
              _XtString name = NULL);
   FormDialog(_XtString name, Widget parent);
};


#endif
