/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* Label.h,v 1.5 1995/10/19 12:44:23 pgw Exp */

#if !defined(_XARM_LABEL_H_)
#define _XARM_LABEL_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/Primitive.h>

class LabelClass : public PrimitiveClass {
 protected:
   LabelClass() {} /* only a derived class can make this */

   virtual WidgetClass classPointer() { return xmLabelWidgetClass; }
   /* class name */
   virtual _XtString className() { return (_XtString) "XmLabel"; }
 public:
   /* resources */
   void accelerator(_XtString str);
   _XtString accelerator();
   void acceleratorText(char *str);
   char *acceleratorText();
   void alignment(unsigned char);
   unsigned char alignment();
   void fontList(XmFontList);
   XmFontList fontList();
   void labelInsensitivePixmap(Pixmap);
   Pixmap labelInsensitivePixmap();
   void labelPixmap(Pixmap);
   Pixmap labelPixmap();
   void labelString(char *str);
   char *labelString();
   void labelType(unsigned char);
   unsigned char labelType();
   void marginBottom(Dimension);
   Dimension marginBottom();
   void marginHeight(Dimension);
   Dimension marginHeight();
   void marginLeft(Dimension);
   Dimension marginLeft();
   void marginRight(Dimension);
   Dimension marginRight();
   void marginTop(Dimension);
   Dimension marginTop();
   void marginWidth(Dimension);
   Dimension marginWidth();
   void mnemonic(KeySym);
   KeySym mnemonic();
   void mnemonicCharSet(_XtString);
   _XtString mnemonicCharSet();
   void recomputeSize(Boolean); 
   Boolean recomputeSize();
   void stringDirection(XmStringDirection);
   XmStringDirection stringDirection();
};

class Label : public LabelClass {
 public:
   Label(Widget parent, char *str, _XtString name = NULL);
   Label(Widget parent, 
         ArgList arglist = NULL, 
         Cardinal cnt = 0, 
         _XtString name = NULL);
   Label(_XtString name, Widget parent); 
};

#endif
