/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* MessageB.h,v 1.5 1995/10/19 12:44:28 pgw Exp */

#if !defined(_XARM_MESSAGEB_H_)
#define _XARM_MESSAGEB_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/BulletinB.h>

class MessageBoxClass : public BulletinBoardClass {
 protected:
   MessageBoxClass() {}
   virtual WidgetClass classPointer() { return xmMessageBoxWidgetClass; }
   virtual _XtString className() { return (_XtString) "XmMessageBox"; }
 public:
   /* convenience rountines */
   Widget getChild(unsigned char);

   /* callbacks */
   void cancelCallback(XtCallbackProc funcp, XtPointer data = NULL);
   void okCallback(XtCallbackProc funcp, XtPointer data = NULL);

   /* resources */
   void cancelLabelString(char *);
   char *cancelLabelString();
   void defaultButtonType(unsigned char);
   unsigned char defaultButtonType();
   void dialogType(unsigned char);
   unsigned char dialogType();
   void messageAlignment(unsigned char);
   unsigned char messageAlignment();
   void messageString(char *);
   char * messageString();
   void minimizeButtons(Boolean);
   Boolean minimizeButtons();
   void okLabelString(char *);
   char *okLabelString();
   void symbolPixmap(Pixmap);
   Pixmap symbolPixmap();
};

class MessageBox : public MessageBoxClass {
 protected:
   virtual Widget createWidget(_XtString name,
                               Widget parent,
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   MessageBox(Widget parent,char *str, _XtString name = NULL);
   MessageBox(Widget parent,
              ArgList arglist = NULL,
              Cardinal cnt = 0,
              _XtString name = NULL);
   MessageBox(_XtString name, Widget parent);
};

class MessageDialog : public MessageBoxClass {
 protected:
   virtual Widget createWidget(_XtString name,
                               Widget parent,
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   MessageDialog(Widget parent,char *str, _XtString name = NULL);
   MessageDialog(Widget parent,
                 ArgList arglist = NULL, 
                 Cardinal cnt = 0,
                 _XtString name = NULL);
   MessageDialog(_XtString name, Widget parent);
};

class QuestionDialog : public MessageBoxClass {
 protected:
   virtual Widget createWidget(_XtString name,
                               Widget parent,
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   QuestionDialog(Widget parent, char *mesg, _XtString name = NULL);
   QuestionDialog(Widget parent,
                  ArgList arglist = NULL, 
                  Cardinal cnt = 0,
                  _XtString name = NULL);
   QuestionDialog(_XtString name, Widget parent);
};

class InformationDialog : public MessageBoxClass { 
 protected:
   virtual Widget createWidget(_XtString name,
                               Widget parent,
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   InformationDialog(Widget parent, char *mesg, _XtString name = NULL);
   InformationDialog(Widget parent, 
                     ArgList arglist = NULL,
                     Cardinal cnt = 0,
                     _XtString name = NULL);
   InformationDialog(_XtString name, Widget parent);
};

class ErrorDialog : public MessageBoxClass { 
 protected:
   virtual Widget createWidget(_XtString name,
                               Widget parent,
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   ErrorDialog(Widget parent, char *mesg, _XtString name = NULL);
   ErrorDialog(Widget parent,
               ArgList arglist = NULL,
               Cardinal cnt = 0,
               _XtString name = NULL);
   ErrorDialog(_XtString name, Widget parent);
};

class WarningDialog : public MessageBoxClass { 
 protected:
   virtual Widget createWidget(_XtString name,
                               Widget parent,
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   WarningDialog(Widget parent, char *mesg, _XtString name = NULL);
   WarningDialog(Widget parent,
                 ArgList arglist = NULL,
                 Cardinal cnt = 0,
                 _XtString name = NULL);
   WarningDialog(_XtString name, Widget parent);
};

class WorkingDialog : public MessageBoxClass { 
 protected:
   virtual Widget createWidget(_XtString name,
                               Widget parent,
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   WorkingDialog(Widget parent, char *mesg, _XtString name = NULL);
   WorkingDialog(Widget parent,
                 ArgList arglist = NULL,
                 Cardinal cnt = 0,
                 _XtString name = NULL);
   WorkingDialog(_XtString name, Widget parent);
};


#endif
