/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* PanedW.h,v 1.5 1995/10/19 12:44:30 pgw Exp */

#if !defined(_XARM_PANEDW_H_)
#define _XARM_PANEDW_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/Manager.h>

class PanedWindowClass : public ManagerClass {
 protected:
   PanedWindowClass() {}
   virtual WidgetClass classPointer() { return xmPanedWindowWidgetClass; }
   virtual _XtString className() { return (_XtString) "XmPanedWindow"; }
 public:
   /* resources */
   void marginHeight(Dimension);
   Dimension marginHeight();
   void marginWidth(Dimension);
   Dimension marginWidth();
   void refigureMode(Boolean);
   Boolean refigureMode();
   void sashHeight(Dimension);
   Dimension sashHeight();
   void sashIndent(Position);
   Position sashIndent();
   void sashShadowThickness(Dimension);
   Dimension sashShadowThickness();
   void sashWidth(Dimension);
   Dimension sashWidth();
   void separatorOn(Boolean);
   Boolean separatorOn();
   void spacing(Dimension);
   Dimension spacing();
   
};

class PanedWindow : public PanedWindowClass {
 public:
   PanedWindow(Widget parent,
               ArgList arglist = NULL,
               Cardinal cnt = 0,
               _XtString name = NULL);
   PanedWindow(_XtString name, Widget parent);
};

#endif
