/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* ScrolledW.h,v 1.5 1995/10/19 12:44:36 pgw Exp */

#if !defined(_XARM_SCROLLEDW_H_)
#define _XARM_SCROLLEDW_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/Manager.h>

class ScrolledWindowClass: public ManagerClass {
 protected:
   ScrolledWindowClass() {} /* only a derived class can make this */
   virtual WidgetClass classPointer() { return xmScrolledWindowWidgetClass; }
   virtual _XtString className() { return (_XtString) "XmScrolledWindow"; }
 public:
   /* callbacks */
   void traverseObscuredCallback(XtCallbackProc funcp, XtPointer data = NULL);

   /* resources */
   Widget horizontalScrollBar();
   void horizontalScrollBar(Widget);
   void scrollBarDisplayPolicy(unsigned char); 
   unsigned char scrollBarDisplayPolicy(); 
   void scrollBarPlacement(unsigned char);
   unsigned char scrollBarPlacement();
   void scrolledWindowMarginHeight(Dimension);
   Dimension scrolledWindowMarginHeight();
   void scrolledWindowMarginWidth(Dimension);
   Dimension scrolledWindowMarginWidth();
   unsigned char scrollingPolicy(); 
   void spacing(int);
   int spacing();
   Widget verticalScrollBar();
   void verticalScrollBar(Widget);
   unsigned char visualPolicy();
   void workWindow(Widget);
   Widget workWindow();
};

class ScrolledWindow : public ScrolledWindowClass {
 public:
   ScrolledWindow(Widget parent,
                  ArgList arglist = NULL,
                  Cardinal cnt = 0,
                  _XtString name = NULL);
   ScrolledWindow(_XtString name, Widget parent);
};

#endif
