/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* SelectioB.h,v 1.5 1995/10/19 12:44:37 pgw Exp */

#if !defined(_XARM_SELECTIOB_H_)
#define _XARM_SELECTIOB_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/BulletinB.h>

class SelectionBoxClass : public BulletinBoardClass {
 protected:
   SelectionBoxClass() {}
   virtual WidgetClass classPointer() { return xmSelectionBoxWidgetClass; }
   virtual _XtString className() { return (_XtString) "XmSelectionBox"; } 
 public:
   /* callbacks */
   void applyCallback(XtCallbackProc funcp, XtPointer data = NULL);
   void cancelCallback(XtCallbackProc funcp, XtPointer data = NULL);
   void noMatchCallback(XtCallbackProc funcp, XtPointer data = NULL);
   void okCallback(XtCallbackProc funcp, XtPointer data = NULL);

   /* convenience routines */
   virtual Widget getChild(unsigned char);

   /* resources */
   void applyLabelString(char *);
   char *applyLabelString();
   void cancelLabelString(char *);
   char *cancelLabelString();
   void childPlacement(unsigned char);
   unsigned char childPlacement();
   void dialogType(unsigned char);
   unsigned char dialogType();
   void helpLabelString(char *);
   char *helpLabelString();
   void listItemCount(int);
   int listItemCount();
   void listItems(XmStringTable);
   XmStringTable listItems();
   void listLabelString(char *);
   char *listLabelString();
   void listVisibleItemCount(int);
   int listVisibleItemCount();
   void minimizeButtons(Boolean);
   Boolean minimizeButtons();
   void mustMatch(Boolean);
   Boolean mustMatch();
   void okLabelString(char *);
   char *okLabelString();
   void selectionLabelString(char *str);
   char *selectionLabelString();
   void textColumns(short);
   short textColumns();
   void textString(char *str);
   char *textString();
};

class SelectionBox : public SelectionBoxClass {
 protected:
   virtual Widget createWidget(_XtString name,
                               Widget parent,
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   SelectionBox(Widget parent, 
                ArgList arglist = NULL,
                Cardinal cnt = 0,
                _XtString name = NULL);
   SelectionBox(_XtString name, Widget parent);
};

class SelectionDialog : public SelectionBoxClass {
 protected:
   virtual Widget createWidget(_XtString name,
                               Widget parent,
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   SelectionDialog(Widget parent,
                   ArgList arglist = NULL,
                   Cardinal cnt = 0,
                   _XtString name = NULL);
   SelectionDialog(_XtString name, Widget parent);
};

class PromptDialog : public SelectionBoxClass {
 protected:
   virtual Widget createWidget(_XtString name,
                               Widget parent,
                               ArgList arglist = NULL,
                               Cardinal cnt = 0);
 public:
   PromptDialog(Widget parent, char *mesg, _XtString name = NULL);
   PromptDialog(Widget parent,
                ArgList arglist = NULL,
                Cardinal cnt = 0,
                _XtString name = NULL);
   PromptDialog(_XtString name, Widget parent);
};

#endif
