/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* ToggleB.h,v 1.5 1995/10/19 12:44:42 pgw Exp */

#if !defined(_XARM_TOGGLEB_H_)
#define _XARM_TOGGLEB_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/Label.h>

class ToggleButtonClass : public LabelClass {
 protected:
   ToggleButtonClass() {}

   /* class pointer */
   virtual WidgetClass classPointer() { return xmToggleButtonWidgetClass; }
   /* class name */
   virtual _XtString className() { return (_XtString) "XmToggleButton"; }
 public:
   /* callbacks */
   void armCallback(XtCallbackProc funcp, XtPointer data = NULL); 
   void disarmCallback(XtCallbackProc funcp, XtPointer data = NULL); 
   void valueChangedCallback(XtCallbackProc funcp, XtPointer data = NULL); 

   /* convenience */
   Boolean getState();
   void setState(Boolean state, Boolean notify = FALSE);

   /* resources */
   void fillOnSelect(Boolean);
   Boolean fillOnSelect();
   void indicatorOn(Boolean);
   Boolean indicatorOn();
   void indicatorSize(Dimension);
   Dimension indicatorSize();
   void indicatorType(unsigned char);
   unsigned char indicatorType();
   void selectColor(Pixel);
   Pixel selectColor();
   void selectInsensitivePixmap(Pixmap);
   Pixmap selectInsensitivePixmap();
   void set(Boolean);
   Boolean set();
   void spacing(Dimension);
   Dimension spacing();
   void visibleWhenOff(Boolean);
   Boolean visibleWhenOff();
};
   
class ToggleButton : public ToggleButtonClass {
 public:
   ToggleButton(Widget parent, 
                char *text, 
                KeySym mn = 0, 
                _XtString acc = NULL, 
                char *acc_text = NULL, 
                _XtString name = NULL);
   ToggleButton(Widget parent,
                ArgList arglist = NULL, 
                Cardinal cnt = 0, 
                _XtString name = NULL);
   ToggleButton(_XtString name, Widget parent);
};

#endif
