/* Property.h,v 1.5 1995/10/02 15:05:42 pgw Exp */

#if !defined(_XM_PROPERTY_H_)
#define _XM_PROPERTY_H_

#include <Xm/BulletinB.h>

#if defined(__cplusplus)
extern "C" {
#endif

/* ======================================================================== */
/* PropertyPage Widget defines new callback resources */

extern WidgetClass xmPropertyPageWidgetClass;
typedef struct _XmPropertyPageRec *XmPropertyPageWidget;
typedef struct _XmPropertyPageClassRec *XmPropertyPageWidgetClass;

#define XmIsPropertyPage(w) XtIsSubclass((w), xmPropertyPageWidgetClass)

Widget XmCreatePropertyPage(Widget parent,  
                             char *name, 
                             Arg *arglist, 
                             Cardinal argcount);

/* new resource definitions */                         /* Access */
#define XmNsetActiveCallback "setActiveCallback"          /* CSG */
#define XmNkillActiveCallback "killActiveCallback"        /* CSG */

/* ======================================================================== */
/* PropertySheet Widget */

extern WidgetClass xmPropertySheetWidgetClass;
typedef struct _XmPropertySheetRec *XmPropertySheetWidget;
typedef struct _XmPropertySheetClassRec *XmPropertySheetWidgetClass;

#define XmIsPropertySheet(w) XtIsSubclass((w), xmPropertySheetWidgetClass)

Widget XmCreatePropertySheet(Widget parent,  
                             char *name, 
                             Arg *arglist, 
                             Cardinal argcount);

Widget XmCreatePropertySheetDialog(Widget parent,  
                             char *name, 
                             Arg *arglist, 
                             Cardinal argcount);

/*
 * child is one of these (defined in Xm.h) 
 * XmDIALOG_APPLY_BUTTON, 
 * XmDIALOG_CANCEL_BUTTON, 
 * XmDIALOG_OK_BUTTON 
 */
Widget XmPropertySheetGetChild(Widget widget, unsigned char child);

Widget XmPropertySheetGetPage(Widget sheet, int position);
void XmPropertySheetAddPage(Widget sheet, Widget page, int position);
void XmPropertySheetRemovePos(Widget sheet, int position);
void XmPropertySheetRemovePage(Widget sheet, Widget page);
void XmPropertySheetSetActivePage(Widget sheet, Widget page, Boolean notify);
void XmPropertySheetSetActivePos(Widget sheet, int position, Boolean notify);

/* new resource definitions */               /* Access */
#define XmNactivePos "activePos"             /*   G */
#define XmNcornerStyle "cornerStyle"         /* CSG */
#define XmNpageCount "pageCount"             /*   G */
#define XmNpages "pages"                     /*   G */
#define XmNtabs "tabs"                       /*   G */

/* new resource class definitions */
#define XmCActivePos "ActivePos"
#define XmCCornerStyle "CornerStyle"
#define XmCPageCount "PageCount"
#define XmCPages "Pages"
#define XmCTabs "Tabs"

/* tabs are always oriented on top because of buttons. */

/* enums for corner styles for tabs */
enum {
   XmCORNER_NONE,
   XmCORNER_ARC,
   XmCORNER_LINE,
};

#if defined(__cplusplus)
}
#endif

#endif

