/* PropertyP.h,v 1.6 1995/10/02 15:05:43 pgw Exp */

#if !defined(_XM_PROPERTYP_H_)
#define _XM_PROPERTYP_H_

#include <Xm/XmP.h>
#include <Xmext/Property.h>
#include <Xm/BulletinBP.h>

#if defined(__cplusplus)
extern "C" {
#endif

/* ======================================================================== */
/* PropertyPage Widget */
/* Define the page instance part */
typedef struct {
   XtCallbackList kill_active_callback;
   XtCallbackList set_active_callback;
   XtCallbackList cancel_callback;
   XtCallbackList apply_callback;
   XtCallbackList ok_callback;
} XmPropertyPagePart;

/* Define the full instance record */
typedef struct _XmPropertyPageRec {
   /* inherit from the following */
   CorePart core;
   CompositePart composite;
   ConstraintPart constraint;
   XmManagerPart manager;
   XmBulletinBoardPart bulletin_board;
   /* self */
   XmPropertyPagePart property_page;
} XmPropertyPageRec;
   
/* Define class part structure */
typedef struct {
   XtPointer extension;
} XmPropertyPageClassPart;

/* Define the full class record */
typedef struct _XmPropertyPageClassRec {
   CoreClassPart core_class;
   CompositeClassPart composite_class;
   ConstraintClassPart constraint_class;
   XmManagerClassPart manager_class;
   XmBulletinBoardClassPart bulletin_board_class;
   XmPropertyPageClassPart property_page_class;
} XmPropertyPageClassRec;

extern XmPropertyPageClassRec xmPropertyPageClassRec;

/* ======================================================================== */
/* PropertySheet Widget */
/* Define the sheet instance part */
typedef struct {
   int active_pos;

   XmString apply_label_string;
   XtCallbackList apply_callback;
   Widget apply_button;

   XmString cancel_label_string;
   XtCallbackList cancel_callback;

   unsigned char corner_style;

   XmString ok_label_string;
   XtCallbackList ok_callback;
   Widget ok_button;

   int page_count;
   WidgetList pages;
   WidgetList tabs;

} XmPropertySheetPart;

/* Define the full instance record */
typedef struct _XmPropertySheetRec {
   /* inherit from the following */
   CorePart core;
   CompositePart composite;
   ConstraintPart constraint;
   XmManagerPart manager;
   XmBulletinBoardPart bulletin_board;
   /* self */
   XmPropertySheetPart property_sheet;
} XmPropertySheetRec;
   
/* Define class part structure */
typedef struct {
   XtPointer extension;
} XmPropertySheetClassPart;

/* Define the full class record */
typedef struct _XmPropertySheetClassRec {
   CoreClassPart core_class;
   CompositeClassPart composite_class;
   ConstraintClassPart constraint_class;
   XmManagerClassPart manager_class;
   XmBulletinBoardClassPart bulletin_board_class;
   XmPropertySheetClassPart property_sheet_class;
} XmPropertySheetClassRec;

extern XmPropertySheetClassRec xmPropertySheetClassRec;

#if defined(__cplusplus)
};
#endif

#endif
