/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* CascadeBG.C,v 1.4 1995/10/19 12:44:56 pgw Exp */

#include <Xarm/CascadeBG.h>

/* CascadeButtonGadgetClass member functions */
void
CascadeButtonGadgetClass::activateCallback(XtCallbackProc fp, XtPointer udata)
{
   addCallback(XmNactivateCallback,fp,udata);
}

void
CascadeButtonGadgetClass::cascadingCallback(XtCallbackProc fp, XtPointer udata)
{
   addCallback(XmNcascadingCallback,fp,udata);
}

void
CascadeButtonGadgetClass::cascadePixmap(Pixmap id)
{
   XtVaSetValues(widget(),XmNcascadePixmap,id, NULL);
}

Pixmap
CascadeButtonGadgetClass::cascadePixmap()
{
   Pixmap id;
   XtVaSetValues(widget(),XmNcascadePixmap, &id, NULL);
   return id;
}

void
CascadeButtonGadgetClass::mappingDelay(int delay)
{
   XtVaSetValues(widget(),XmNmappingDelay,delay, NULL);
}   

int
CascadeButtonGadgetClass::mappingDelay()
{
   int delay;
   XtVaSetValues(widget(),XmNmappingDelay, &delay, NULL);
   return delay;
}   

void
CascadeButtonGadgetClass::subMenuId(Widget sub)
{
   if(sub)
   {
      XtVaSetValues(widget(),XmNsubMenuId,sub, NULL);
   }
}

Widget
CascadeButtonGadgetClass::subMenuId()
{
   Widget w;
   XtVaSetValues(widget(),XmNsubMenuId,&w, NULL);
   return w;
}

/* constructors */
CascadeButtonGadget::CascadeButtonGadget(Widget parent, char *str, _XtString name)
{
   Widget wid = createWidget(name, parent);
   widget(wid);
   labelString(str);
   manage();
}

CascadeButtonGadget::CascadeButtonGadget(Widget parent, 
                                         ArgList arglist, 
                                         Cardinal cnt,
                                         _XtString name)
{
   Widget wid = createWidget(name, parent, arglist, cnt);
   widget(wid);
   manage();
}

CascadeButtonGadget::CascadeButtonGadget(_XtString name, Widget parent)
{
   Widget wid = createWidget(name, parent);
   widget(wid);
   manage();
}
/* */
