/*
 * Copyright (C) 1994 Jettero Heller
 * Copyright (C) 1994, 1995 Peter Williams
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* Form.C,v 1.4 1995/10/19 12:45:00 pgw Exp */
#include <Xarm/Form.h>

/* resources */
void 
FormClass::fractionBase(int i)
{
   XtVaSetValues(widget(),XmNfractionBase, i, NULL);
}

int 
FormClass::fractionBase()
{
   int i;
   XtVaGetValues(widget(),XmNfractionBase, &i, NULL);
   return i;
}

void 
FormClass::horizontalSpacing(Dimension d)
{
   XtVaSetValues(widget(),XmNhorizontalSpacing,d,NULL);
}

Dimension 
FormClass::horizontalSpacing()
{
   Dimension d;
   XtVaGetValues(widget(),XmNhorizontalSpacing, &d,NULL);
   return d;
}

void 
FormClass::rubberPositioning(Boolean b)
{
   XtVaSetValues(widget(),XmNrubberPositioning,b,NULL);
}

Boolean 
FormClass::rubberPositioning()
{
   Boolean b;
   XtVaGetValues(widget(),XmNrubberPositioning, &b,NULL);
   return b;
}

void 
FormClass::verticalSpacing(Dimension d)
{
   XtVaSetValues(widget(),XmNverticalSpacing,d,NULL);
}

Dimension
FormClass::verticalSpacing()
{
   Dimension d;
   XtVaGetValues(widget(),XmNverticalSpacing,&d,NULL);
   return d;
}

/* constructor */
Form::Form(Widget parent, ArgList arglist, Cardinal cnt, _XtString name)
{
   Widget wid = createWidget(name, parent, arglist, cnt);
   widget(wid);
}

Form::Form(_XtString name, Widget parent)
{
   Widget wid = createWidget(name, parent);
   widget(wid);
}

Widget
FormDialog::createWidget(_XtString name, 
                         Widget parent, 
                         ArgList arglist,
                         Cardinal cnt)
{

   if (name == NULL || *name == '\0') { name = className(); }
   return XmCreateFormDialog(parent, name , arglist, cnt);
}


FormDialog::FormDialog(Widget parent,
                       ArgList arglist,
                       Cardinal cnt,
                       _XtString name)
{
   Widget wid = createWidget(name, parent, arglist, cnt);
   widget(wid);
}

FormDialog::FormDialog(_XtString name, Widget parent)
{
   Widget wid = createWidget(name, parent);
   widget(wid);
}

